<!--  -->
<template>
  <div class=''>
    <el-breadcrumb class="divi2" separator-class="el-icon-arrow-right">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>算法管理</el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider class="divi"></el-divider>

    <el-form :inline="true" :model="dataForm" @keyup.enter.native="getDataList()">
      <el-form-item>
        <el-button v-if="isAuth('algs:save')" type="primary" @click="addHandle()">新建算法</el-button>
        <el-button v-if="isAuth('algs:delete')" type="danger" @click="deleteHandle()"
          :disabled="dataListSelections.length <= 0">批量删除</el-button>
      </el-form-item>
      <el-form-item>
        <el-input v-model="dataForm.algorithmName" placeholder="请输入算法名称" clearable
          @keyup.enter.native="pageIndex = 1;getDataList()"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="pageIndex = 1;getDataList()">查询</el-button>
      </el-form-item>
      <el-form-item>
        <el-tag>筛选:</el-tag>
        <el-select v-model="classificationtag" placeholder="类别" size="mini" style="width: 130px;"
          @change="pageIndex = 1;getDataList2()">
          <el-option v-for="data in classification" :key="data" :label="data" :value="data">
          </el-option>
        </el-select>
      </el-form-item>
    </el-form>

    <el-table :data="dataList" border v-loading="dataListLoading" @selection-change="selectionChangeHandle"
      style="width: 100%;">
      <el-table-column type="selection" header-align="center" align="center" width="50">
      </el-table-column>
      <!-- <el-table-column prop="algorithmId" header-align="center" align="center" width="80" label="算法ID">
      </el-table-column> -->
      <el-table-column label="序号" header-align="center" align="center" width="80" type="index" :index='(index)=>{return (index+1) + (this.pageIndex-1)*this.pageSize}'> </el-table-column>

      <el-table-column  prop="algorithmName" header-align="center" align="center" label="算法名称">
      </el-table-column>
      <el-table-column prop="categoryName" header-align="center" align="center" label="分类">
      </el-table-column>
      <el-table-column prop="username" header-align="center" align="center" label="创建人">
      </el-table-column>
      <el-table-column prop="number" header-align="center" align="center" label="版本数量" >
      </el-table-column>
      <el-table-column fixed="right" header-align="center" align="center" width="250" label="操作">
        <template slot-scope="scope">
          <el-button v-if="isAuth('algs:list')" type="text" size="small" @click="userwatch(scope.row.algorithmId)">查看
          </el-button>
          <el-button v-if="scope.row.frameId !== -1" type="text" size="small" @click="versionsList(scope.row.algorithmId)">版本列表
          </el-button>
          <el-button v-if="scope.row.frameId === -1" type="text" size="small" @click="traFileList(scope.row.algorithmId)">编辑传统算法文件
          </el-button>
          <!-- <el-button v-if="scope.row.frameId === -1" type="text" size="small" @click="getAlgParameter(scope.row.algorithmId)">参数
          </el-button> -->
          <el-button v-if="isAuth('algs:update')" type="text" size="small"
            @click="updateHandle(scope.row.algorithmId)">修改</el-button>
          <el-button v-if="isAuth('algs:delete')" type="text" size="small"
            @click="deleteHandle(scope.row.algorithmId)">
            删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination @size-change="sizeChangeHandle" @current-change="currentChangeHandle" :current-page="pageIndex"
      :page-sizes="[10, 20, 50, 100]" :page-size="pageSize" :total="totalPage"
      layout="total, sizes, prev, pager, next, jumper">
    </el-pagination>
    <!-- 弹窗, 新增 / 修改 -->
    <Watch v-if="newWatchVisible" ref="newWatch" @refreshDataList="getDataList"></Watch>
    <Add v-if="addVisible" ref="addS" @refreshDataList="getDataList"></Add>
    <!-- <alg-add v-if="addVisible" ref="addS" @refreshDataList="getDataList"></alg-add> -->
    <AlgAdd v-if="addVisible" ref="addS" @refreshDataList="getDataList"></AlgAdd>
    <Watch v-if="newWatchVisible" ref="newWatch" @refreshDataList="getDataList"></Watch>
    <Update v-if="updateVisible" ref="newUpdate" @refreshDataList="getDataList"></Update>
    <GetPara v-if="getAlgParaVisible" ref="newGetAlgPara" @refreshDataList="getDataList"></GetPara>
  </div>
</template>

<script>
import AlgAdd from './alg-add.vue';
import Watch from './alg-watch.vue';
import Update from './alg-update.vue';
import GetPara from './getalgpara.vue'
import { MessageBox } from 'element-ui'
import { Message } from "element-ui"
// import AlgAdd from './alg-add.vue';
//这里可以导入其他文件（比如：组件，工具js，第三方插件js，json文件，图片文件等等）
//例如：import 《组件名称》 from '《组件路径》';


export default {
  //import引入的组件需要注入到对象中才能使用
  data() {
    return {
      dataForm: {
        algorithmName: "",
      },
      dataList: [],
      pageIndex: 1,
      pageSize: 10,
      totalPage: 0,
      dataListLoading: false,
      dataListSelections: [],
      updateVisible: false,
      newWatchVisible: false,
      addVisible: false,
      getAlgParaVisible: false,
      classificationtag: "",
      classification: [],
    };
  },
  components: {
    AlgAdd,
    Watch,
    Update,
    GetPara
  },

  activated() {
    this.getDataList();
  },
  methods: {
    // 获取数据列表
    getDataList() {
      this.dataListLoading = true;
      this.classificationtag = null;
      this.$http({
        url: this.$http.adornUrl("/category/select"),
        method: "get",
      }).then(({ data }) => {
        this.classification = this.unique(data.list);
      });

      this.$http({
        url: this.$http.adornUrl("/algs/list"),
        method: "get",
        params: this.$http.adornParams({
          page: this.pageIndex,
          limit: this.pageSize,
          algorithmName: this.dataForm.algorithmName,
        }),
      }).then(({ data }) => {
        if (data && data.code === 0) {
          this.dataList = data.page.list;
          this.totalPage = data.page.totalCount;
          this.statusunique = this.unique(data.page.list);
        } else {
          this.dataList = [];
          this.totalPage = 0;
        }
        this.dataListLoading = false;
      });
    },
    //筛选查询
    getDataList2() {
      this.dataListLoading = true;
      this.$http({
        url: this.$http.adornUrl("/algs/list"),
        method: "get",
        params: this.$http.adornParams({
          page: this.pageIndex,
          limit: this.pageSize,
          algorithmName: this.dataForm.algorithmName,
          classificationtag: this.classificationtag,
        }),
      }).then(({ data }) => {
        if (data && data.code === 0) {
          this.dataList = data.page.list;
          this.totalPage = data.page.totalCount;
        } else {
          this.dataList = [];
          this.totalPage = 0;
        }
        this.dataListLoading = false;
      });
    },
    stateFormat(row, column) {
      if (row.datasetStatus === 1) {
        return "静态数据集";
      } else {
        return "动态数据集";
      }
    },
    //去重
    unique(arr) {
      var ss = [];
      for (var i = 0; i < arr.length; i++) {
        ss[i] = arr[i].categoryName;
      }
      return Array.from(new Set(ss));
    },
    // 每页数
    sizeChangeHandle(val) {
      this.pageSize = val;
      this.pageIndex = 1;
      this.getDataList();
    },
    // 当前页
    currentChangeHandle(val) {
      this.pageIndex = val;
      this.getDataList();
    },
    // 多选
    selectionChangeHandle(val) {
      this.dataListSelections = val;
    },
    // 查看
    userwatch(id) {
      this.newWatchVisible = true;
      this.$nextTick(() => {
        this.$refs.newWatch.init(id);
      });
    },
    // 现在这里只处理修改了
    updateHandle(id) {
      this.updateVisible = true;
      this.$nextTick(() => {
        this.$refs.newUpdate.init(id);
      });
    },
    // 这里处理新建
    addHandle(){
      this.addVisible = true;
      this.$nextTick(() => {
        this.$refs.addS.init();
      });
    },
    //查看传统算法参数
    getAlgParameter(id){
      console.log("获取参数");
      console.log(id);
      this.getAlgParaVisible=true;
      this.$nextTick(() => {
        this.$refs.newGetAlgPara.init(id);
      });
    },
    // 删除
    deleteHandle(id) {
      var algorithmId = id
        ? [id]
        : this.dataListSelections.map((item) => {
            return item.algorithmId;
          });
      MessageBox.confirm(
        `确定对[id=${algorithmId.join(",")}]进行[${id ? "删除" : "批量删除"}]操作?`,
        "提示",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(() => {
          this.$http({
            url: this.$http.adornUrl("/algs/delete"),
            method: "post",
            data: this.$http.adornData(algorithmId, false),
          }).then(({ data }) => {
            if (data && data.code === 0) {
              Message({
                message: "操作成功",
                type: "success",
                duration: 1500,
                onClose: () => {
                  this.getDataList();
                },
              });
              this.pageIndex = 1;
              getDataList();
            } else {
              Message.error(data.msg);
            }
          });
        })
        .catch(() => {});
    },
    
    //查看智能算法版本列表
    versionsList(id) {
      this.$router.replace({ name: 'version',query:{algorithmNameToVersion:id} });
    },

    //查看传统算法文件列表
    traFileList(id) {
      this.$router.replace({ name: 'trafilelist',query:{algorithmNameToVersion:id} });
    }
  },
};
</script>
</script>
<style scoped>
.divi {
  display: block;
  height: 1px;
  width: 100%;
  margin: 24px 0;
  background-color: #dcdfe6;
  position: relative;
}
.divi2 {
  display: block;
  height: 1px;
  width: 100%;
  position: relative;
}
.sele {
  border: 1px solid #409eff;
  border-radius: 5px;
  box-sizing: border-box;
  padding: 5px 0px;
  margin: 10px;
}
</style>
